package com.uncontrol {
	import com.uncontrol.BoilerPlate;

	public class SimplePlotter extends BoilerPlate {

		private var leadPoint:Object;
		private var followPoint:Object;

		private var a:Object;
		private var b:Object;
		private var c:Object;
		private var d:Object;
		private var e:Object;
		private var f:Object;
				
		private var elasticity:Number = .1;
		private var smoothness:Number = .5;
		
		public function SimplePlotter():void {
			setScope('SimplePlotter');
		}
		
		public function init():void {
			tracer('init');
			reset();
		}
		
		public function reset(arg:Object = null):void {
			// tracer('reset');

			if(arg == null){
				arg = { x:0 , y:0};
			}
			followPoint = { x:arg.x , y:arg.y};
			leadPoint = { x:arg.x , y:arg.y};
			
			a = { x:arg.x , y:arg.y};
			b = { x:arg.x , y:arg.y};
			c = { x:arg.x , y:arg.y};
			d = { x:arg.x , y:arg.y};
			e = { x:arg.x , y:arg.y};
			f = { x:arg.x , y:arg.y};
		}
		
		public function parse():void {

			a.x = leadPoint.x;
			a.y = leadPoint.y;

			d.x = (a.x - b.x)*elasticity + b.x;
			e.x = b.x - (b.x-c.x) - (b.x-d.x);
			f.x = e.x - (b.x-e.x)*smoothness;
			b.x = e.x;
			c.x = f.x 
			          
			d.y = (a.y - b.y)*elasticity + b.y;
			e.y = b.y - (b.y-c.y) - (b.y-d.y);
			f.y = e.y - (b.y-e.y)*smoothness;
			b.y = e.y;
			c.y = f.y 
			          
			a.x = b.x;
			a.y = b.y;
			
			setFollowPoint(a);
		}
		
		// -------------------------------------------------------------------------------------------
		// getter setter methods
		// -------------------------------------------------------------------------------------------
		public function getFollowPoint():Object{
			// return followPoint;
			return { x:followPoint.x , y:followPoint.y};
		}
		public function setFollowPoint(arg:Object=null):void{
			followPoint = { x:arg.x , y:arg.y};
		}
		
		public function getLeadPoint():Object{
			return { x:leadPoint.x , y:leadPoint.y};
		}
		public function setLeadPoint(arg:Object=null):void{
			leadPoint = { x:arg.x , y:arg.y};
		}
		
		public function getElasticity():Number{
			return elasticity;
		}
		public function setElasticity(arg:Number=.1):void{
			elasticity = arg;
		}
		
		public function getSmoothness():Number{
			return smoothness;
		}
		public function setSmoothness(arg:Number=.5):void{
			smoothness = arg;
		}
	}
}


