package com.uncontrol.shifter {
	import com.uncontrol.BoilerPlate;
	import com.uncontrol.shifter.View;
	import com.uncontrol.Plotter;
	import com.uncontrol.SimplePlotter;

 	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.FullScreenEvent;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.display.StageDisplayState;
	
	import flash.display.Shape;
	import flash.display.LineScaleMode;
	import flash.display.CapsStyle;
	import flash.display.JointStyle;
	import flash.ui.Mouse;


	public class Shifter extends BoilerPlate {
		
		private var holder:Sprite;
		private var view:View;
		private var viewStyle:int = 3;
		
		
		private var ribbon:Array;
		private var line:Array;
		
		private var leadPoint:Object;
		private var newPoint:Object;
		
		private var ribbonWidth:int = 10;
		private var maxLength:int = 40;
		
		private var count;
		private var isMouseDown = false;

		public function Shifter():void {
			setScope('Shifter');
			init();
		}
		
		public function init():void{
			tracer('init');
			// creates a sprite and sets it to the center of stage
			holder = new Sprite();
			holder.x = stage.stageWidth/2;
			holder.y = stage.stageHeight/2;
			holder.mouseEnabled = false;
			this.addChild(holder);

			// sets the view for rendering
			view = new View();
			view.setView(holder);
			view.setLineColor(0x000000);
			
			ribbon = new Array();
			line = new Array();
			leadPoint = { x:stage.stageWidth*Math.random() , y:stage.stageHeight*Math.random() };
			newPoint = { x:stage.stageWidth*Math.random() , y:stage.stageHeight*Math.random() };
			
			for(var i:int=0;i<ribbonWidth;i++){
				var plotterData:SimplePlotter = new SimplePlotter();
				plotterData.setElasticity(.6 + .9*(i/ribbonWidth));
				plotterData.setSmoothness(.8);
				// plotterData.setSmoothness(.1-(i/ribbonWidth)*.50);
				plotterData.init();
				line.push(plotterData);
				
				ribbon[i] = new Array();
			}
			
			count = 0;									// iterator
			
			// listener initializations
			this.addEventListener(Event.ENTER_FRAME, onLoop, false, 0, true);
			stage.addEventListener(MouseEvent.MOUSE_UP, onCursorRelease, false, 0, true);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onCursorPress, false, 0, true);	
			
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;	
			
			fullScreenBTN.addEventListener(MouseEvent.CLICK, fullscreenToggle, false, 0, true);	
			fullScreenBTN.buttonMode = true;
			setChildIndex(fullScreenBTN,	this.numChildren-1);
		
			styleBTN.addEventListener(MouseEvent.CLICK, onStyleChanged, false, 0, true);	
			styleBTN.buttonMode = true;
			setChildIndex(styleBTN,	this.numChildren-1);
			
			driveBTN.addEventListener(MouseEvent.CLICK, onDriveChanged, false, 0, true);	
			driveBTN.buttonMode = true;
			setChildIndex(driveBTN,	this.numChildren-1);
			
		}
	
		
		public function fullscreenToggle(e:MouseEvent = null):void {
			tracer('fullscreenToggle');
		
		    //normal mode, enter fullscreen mode
		    if (stage.displayState == StageDisplayState.NORMAL){
		        //set stage display state
		        stage.displayState = StageDisplayState.FULL_SCREEN;
		    }
		    //fullscreen mode, enter normal mode
		    else if (stage.displayState == StageDisplayState.FULL_SCREEN){
		        //set stage display state
		        stage.displayState = StageDisplayState.NORMAL;
		    }
		
			holder.x = stage.stageWidth/2;
			holder.y = stage.stageHeight/2;
			
			onFullscreenChange();
		}

		function onStyleChanged(e:MouseEvent = null):void {
		    if (styleBTN.currentFrame == 1) {
		        styleBTN.gotoAndStop(2);
		    } else {
		        styleBTN.gotoAndStop(1);
		    }
		}
		
		function onDriveChanged(e:MouseEvent = null):void {
		    if (driveBTN.currentFrame == 1) {
		        driveBTN.gotoAndStop(2);
		    } else {
		        driveBTN.gotoAndStop(1);
		    }
		}
		
		function onFullscreenChange(e:FullScreenEvent = null):void {
		    if (stage.displayState == StageDisplayState.FULL_SCREEN) {
		        fullScreenBTN.gotoAndStop(2);
		    } else {
		        fullScreenBTN.gotoAndStop(1);
		    }
		}


		public function onCursorPress(e:MouseEvent):void {
			var smoothnessRandom:Number;
			var elasticityRandom:Number;
		    if (styleBTN.currentFrame == 2) {
				smoothnessRandom = Math.random();
				elasticityRandom = Math.random();
			}
			for(var i:int=0;i<ribbonWidth;i++){
			    if (styleBTN.currentFrame == 1) {
					smoothnessRandom = Math.random();
					elasticityRandom = Math.random();
				}
		
				var plotterData:SimplePlotter = line[i];

				plotterData.setElasticity((.9*elasticityRandom)*(i/ribbonWidth) + .1);
				plotterData.setSmoothness(smoothnessRandom*.9+.1);
				
			}
			
			isMouseDown = true;				// toggle used for loop
			viewStyle++;
			viewStyle = viewStyle%5;
		}
		
		public function onCursorRelease(e:MouseEvent):void {
			isMouseDown = false;			// toggle used for loop
		
		}
	
		public function onLoop(e:Event=null):void{
			var i:int;
			var j:int;
			var plotterData:SimplePlotter;
			var percentage:Number;
			var alpha:Number;
			var currline:Array;
			var prevline:Array
			var squarePoints:Array;
			var boxCount:Number;
			// var direction:Number = 1;
			if(driveBTN.currentFrame == 1){
				if(int(Math.random()*10)==0){
					newPoint = { x:(stage.stageWidth)*Math.random()-stage.stageWidth/2 , y:(stage.stageHeight)*Math.random()-stage.stageHeight/2 };
				}
				
				// direction = int(newPoint.x)%2*2-1;
				
				newPoint.x += Math.cos(count/80*Math.PI*2)*stage.stageHeight*.1;
				newPoint.y += Math.sin(count/80*Math.PI*2)*stage.stageHeight*.1;
				leadPoint.x += (newPoint.x - leadPoint.x)*.0125;
				leadPoint.y += (newPoint.y - leadPoint.y)*.0125;
					
			} else {
				leadPoint.x = holder.mouseX;
				leadPoint.y = holder.mouseY;
			}
			
			for(i=0; i<ribbonWidth; i++){

				plotterData = line[i];
				// plotterData.setLeadPoint({ x:holder.mouseX , y:holder.mouseY });
				plotterData.setLeadPoint({ x:leadPoint.x , y:leadPoint.y });
				
				plotterData.parse();
				
				ribbon[i].push( plotterData.getFollowPoint() );
				if(ribbon[i].length>maxLength){
					ribbon[i].shift();
				}
			}
			
			view.clear();					// clears view
			
			switch(viewStyle){
				case 0:
					for(i=0; i<ribbonWidth; i++){
					
						percentage = Math.cos((i/ribbonWidth)*Math.PI*2)*.5 + .5;
						alpha = (1 - percentage)*.25;
						view.setLineAlpha(alpha * (i/ribbonWidth)*4);
						view.drawStaticShapeWithArray(ribbon[i],false);
					}
				break;
				
				case 1:
					boxCount = 0;
					for(i=1; i<ribbonWidth; i++){
						if(boxCount%2==0){

						currline = ribbon[i];
						prevline = ribbon[i-1];
						for(j=1; j<currline.length; j++){
							
								percentage = Math.cos((j/currline.length)*Math.PI*2)*.5 + .5;
								alpha = (1 - percentage)*.25;
								view.setLineAlpha(alpha * (j/currline.length)*4);

								squarePoints = [ currline[j], currline[j-1] , prevline[j-1] , prevline[j] ];
								view.drawStaticShapeWithArrayFill(squarePoints);
							}
						}
						boxCount++;
					}
				break;
				case 2:

					for(i=1; i<ribbonWidth; i++){
						currline = ribbon[i];
						prevline = ribbon[i-1];
						for(j=1; j<currline.length; j++){
							view.setLineColor(view.fadeHex(0x000000,0xFFFFFF*Math.random(),.5));
							
							// view.setLineColor(0xFFFFFF*Math.random());
							
							percentage = Math.cos((j/currline.length)*Math.PI*2)*.5 + .5;
							alpha = (1 - percentage)*.25;
							view.setLineAlpha(alpha * (j/currline.length)*4);

							squarePoints = [ currline[j], currline[j-1] , prevline[j-1] , prevline[j] ];
							view.drawStaticShapeWithArrayFill(squarePoints);
						}
					}
				break;
				case 3:


					for(i=1; i<ribbonWidth; i++){
						currline = ribbon[i];
						prevline = ribbon[i-1];
						for(j=1; j<currline.length; j++){

							percentage = Math.cos((j/currline.length+i/ribbonWidth)*Math.PI*2)*.5 + .5;
							alpha = (1 - percentage)*.25;
							view.setLineAlpha(alpha * (j/currline.length)*4);
							squarePoints = [ currline[j], currline[j-1] , prevline[j-1] , prevline[j] ];
							view.drawStaticShapeWithArrayFill(squarePoints);
						}
					}
				break;
				
				case 4:
					for(i=1; i<ribbonWidth; i++){
						currline = ribbon[i];
						prevline = ribbon[i-1];
						for(j=1; j<currline.length; j++){
							percentage = Math.cos((j/currline.length+i/ribbonWidth)*Math.PI*2)*.5 + .5;
							alpha = (1 - percentage)*.25;
							view.setLineAlpha(alpha * (j/currline.length)*4);
							
							squarePoints = [ currline[j], currline[j-1] , prevline[j] , prevline[j-1] ];
							view.drawStaticShapeWithArrayFill(squarePoints);
						}
					}
				break;
			}
			count++;
		}
	}
}


